Puppet::Type.type(:gem).provide(:ruby) do

  desc "Calls the gem command in a specific version of ruby to install or
    uninstall gems."

  def create
    command = "/opt/rubies/ruby-" + resource[:version] + "/bin/gem"
    args = "install --no-rdoc --no-ri " + resource[:name]
    o = `#{command} #{args}`
    self.fail "Could not install: #{o.chomp}" if o.include?("ERROR")
  end

  def destroy
    command = "/opt/rubies/ruby-" + resource[:version] + "/bin/gem"
    args = "uninstall --executables --all " + resource[:name]
    o = `#{command} #{args}`
    self.fail "Could not uninstall: #{o.chomp}" if o.include?("ERROR")
  end

  def exists?
    command = "/opt/rubies/ruby-" + resource[:version] + "/bin/gem"
    args = "list " + resource[:name] + " -i"
    o = `#{command} #{args}`
    return o.include?("true")
  end

end
