Puppet::Type.newtype(:gem) do

  ensurable

  newparam(:name, :namevar => true) do
    desc "The name of the gem package."
  end

  newparam(:version, :namevar => true) do
    desc "Defines the version of Ruby that the packaging providers should
      use."
  end

  newparam(:application, :namevar => true) do
    desc "Allows per-application definition of gems. This param is not used
      but as a namevar it ensures that gem declarations are unique."
    defaultto 'ruby'
  end

  def self.title_patterns
    identity = lambda { |x| x }
    [
      [
        /^(.*) in (.*) for (.*)$/,
        [
          [ :name, identity ],
          [ :version, identity ],
          [ :application, identity ]
        ]
      ],
      [
        /^(.*) in (.*)$/,
        [
          [ :name, identity ],
          [ :version, identity ]
        ]
      ]
    ]
  end

  autorequire(:package) do
    ['rubies-ruby-' + self[:version]]
  end

end
