# == Type rubies::deploy
#
# Deploys a self-packaged version of Ruby using the Puppet file system
# as a source.
#
# === Parameters
#
# [*title*]
#   (Namevar) The name of the Ruby package to be installed.
#
# === Authors
#
# David McNicol <david@mcnicks.org>
#

define rubies::deploy () {

  $package = "rubies-ruby-${title}"

  file { "/opt/${package}.deb":
    ensure => 'present',
    owner  => 'root',
    group  => 'root',
    mode   => '0644',
    source => "puppet:///public/${package}.deb",
  }

  package { $package:
    ensure   => 'present',
    provider => 'dpkg',
    source   => "/opt/${package}.deb",
    require  => File["/opt/${package}.deb"]
  }

}
